/* Thumb */
(function (window){
	
	var FWDRVPLogo = function(
			parent, 
			source,
			position,
			margins
		){
		
		var self  = this;
		var prototype = FWDRVPLogo.prototype;
		
		this.img_img = null;
		
		this.logoImage_do = null;
		
		this.position_str = position;
		this.source_str = source;
		
		this.margins = margins;
		
		this.isShowed_bl = true;
		this.allowToShow_bl = true;
	
		this.init = function(){
			self.getStyle().pointerEvents = "none";
			
			self.logoImage_do = new FWDRVPDisplayObject("img");
			
			self.img_img = new Image();
			self.img_img.onerror = null;
			self.img_img.onload = self.loadDone;
			self.img_img.src = self.source_str;
			self.hide();
		};
		
		this.loadDone = function(){
			self.setWidth(self.img_img.width);
			self.setHeight(self.img_img.height);
			
			self.logoImage_do.setScreen(self.img_img);
			self.addChild(self.logoImage_do);
			self.logoImage_do.setWidth(self.img_img.width);
			self.logoImage_do.setHeight(self.img_img.height);
			
			self.positionAndResize();
		};
		
		this.positionAndResize = function(){
			
			if(!parent.vidStageWidth) return;
			
			if(self.position_str == "topleft"){
				self.finalX = self.margins;
				self.finalY = self.margins;
			}else if(self.position_str == "topright"){
				self.finalX = parent.vidStageWidth - self.w - self.margins;
				self.finalY = self.margins;
			}else if(self.position_str == "bottomright"){
				self.finalX = parent.vidStageWidth - self.w - self.margins;
				self.finalY = parent.vidStageHeight - self.h - self.margins;
			}else if(self.position_str == "bottomleft"){
				self.finalX = self.margins;
				self.finalY = parent.vidStageHeight - self.h - self.margins;
			}
			
			self.setX(self.finalX);
			self.setY(self.finalY);
		};
		
		//################################//
		/* show / hide */
		//################################//
		this.show = function(animate){
			if(self.isShowed_bl) return;
			self.isShowed_bl = true;
			FWDRVPTweenMax.killTweensOf(self);
			if(animate){
				FWDRVPTweenMax.to(self, .8, {alpha:1, ease:Expo.easeInOut});
			}else{
				self.setAlpha(1);
			}
		};
		
		this.hide = function(animate){
			if(!self.isShowed_bl) return;
			self.isShowed_bl = false;
			FWDRVPTweenMax.killTweensOf(self);
			if(animate){
				FWDRVPTweenMax.to(self, .8, {alpha:0, ease:Expo.easeInOut});
			}else{
				self.setAlpha(0);
			}
		};
		
		
		this.init();
	};
	
	/* set prototype */
    FWDRVPLogo.setPrototype = function(){
    	FWDRVPLogo.prototype = new FWDRVPDisplayObject("div");
    };
    
    FWDRVPLogo.prototype = null;
	window.FWDRVPLogo = FWDRVPLogo;
}(window));