/* Thumb */
(function (window){
	
	var FWDRVPPlaylist = function(
			parent, 
			data
		){
		
		var self  = this;
		var prototype = FWDRVPPlaylist.prototype;
		
		this.moveEvent = null;
		
		this.image_img = null;
		
		this.playlist_ar = null;
		this.thumbs_ar = null;
		
		this.mainHolder_do = null;
		this.bk_do = null;
		this.thumbsHolder_do = null;
		this.nextButton_do = null;
		this.prevButton_do = null;
		this.toolTip_do = null;
		
		this.bkPath_str = data.controllerBkPath_str;
		this.position_str = parent.playlistPosition_str;
		this.toolTipsButtonFontColor_str = data.playlistToolTipFontColor_str;
		
		this.widthToResize;
		this.heightToResize;
		this.mouseX = 0;
		this.mouseY = 0;
		this.dif = 0;
		this.countLoadedThumbs = 0;
		this.curId = 0;
		this.leftId = 0;
		this.finalX = 0;
		this.finalY = 0;
		this.spacerH = 0;
		this.spacerV = 0;
		this.howManyThumbsToDisplayH = 0;
		this.howManyThumbsToDisplayV = 0;
		this.totalThumbs = 0;
		this.totalWidth = parent.playlistWidth;
		this.totalHeight = parent.playlistHeight;
		this.thumbW = data.thumbnailWidth;
		this.thumbH = data.thumbnailHeight;
		this.nextAndPrevSetButtonsMargins = 10;
		this.offsetToRemoveFromStage = (self.nextAndPrevSetButtonsMargins * 2 + data.nextThumbsSetN_img.width) * 2;
		
		this.spacer = 0;
		this.stageWidth = self.totalWidth;
		this.stageHeight = self.totalHeight;
		
		this.loadWithDelayId_to;
		this.showToolTipId_to;
		this.disableThumbsId_to;
		this.disableMouseWheelId_to;
		this.thumbnailsAnimDoneId_to;
		
		this.showPlaylistToolTips_bl = data.showPlaylistToolTips_bl;
		this.hasPlaylist_bl = false;
		this.showPlaylistByDefault_bl = data.showPlaylistByDefault_bl;
		this.repeatBackground_bl =  data.repeatBackground_bl;
		this.addMouseWheelSupport_bl = data.addMouseWheelSupport_bl;
		this.isShowed_bl = true;
		this.allowToSwipe_bl = false;
		this.disableThumbs_bl = false;
		this.disableMouseWheel_bl = false;
		this.isMobile_bl = FWDRVPUtils.isMobile;
	
		this.init = function(){
			self.mainHolder_do = new FWDRVPDisplayObject("div");
			
			if(self.repeatBackground_bl){
				self.mainHolder_do.getStyle().background = "url('" + self.bkPath_str + "')";
			}else{
				self.bk_do = new FWDRVPDisplayObject("img");
				var img = new Image();
				img.src = self.bkPath_str;
				self.bk_do.setScreen(img);
				self.mainHolder_do.addChild(self.bk_do);
			}
			
			self.thumbsHolder_do = new FWDRVPDisplayObject("div");
			self.thumbsHolder_do.setOverflow("visible");
			self.mainHolder_do.addChild(self.thumbsHolder_do);
			self.addChild(self.mainHolder_do);
			self.setupNextAndPrevButtons();
			self.setupDisable();
			
			if(!self.isMobile_bl && self.showPlaylistToolTips_bl){
				self.setupToolTip();
				if(self.screen.addEventListener){
					window.addEventListener('mousemove', self.mouseMoveHandler);
				}else if(self.screen.attachEvent){
					document.attachEvent('onmousemove', self.mouseMoveHandler);
				}
			}
			if(self.isMobile_bl) self.setupMobileMove();
			if(self.addMouseWheelSupport_bl) self.addMouseWheelSupport();
			if(self.showPlaylistByDefault_bl){
				self.hideAndShow();
			}else{
				self.hide();
			}
		};
		
		//#####################################//
		/* resize and position */
		//#####################################//
		this.resizeAndPosition = function(resizePlaylistWithAnim){
			if(!parent.stageWidth) return;
			
			if(self.position_str == "bottom"){
				self.stageWidth = parent.stageWidth;
				self.stageHeight = self.totalHeight;
				self.finalX = 0;
				self.finalY = parent.stageHeight - self.totalHeight;
			}else{
				self.stageWidth = self.totalWidth;
				self.stageHeight = parent.stageHeight;
				self.finalX = parent.stageWidth - self.totalWidth;
				self.finalY = 0;
			}
			
			self.setX(self.finalX);
			self.setY(self.finalY);
			self.mainHolder_do.setWidth(parent.stageWidth);
			self.mainHolder_do.setHeight(self.stageHeight);
			if(self.totalThumbs){
				self.setDataForResize();
				self.positionThumbs(resizePlaylistWithAnim);
			}
			if(self.bk_do){
				self.bk_do.setWidth(self.stageWidth);
				self.bk_do.setHeight(self.stageHeight);
			}
			self.positionNextAndPrevButtons();
		};
		
		//#################################//
		/* update playlist */
		//#################################//
		this.updatePlaylist = function(playlist, id){
			self.hasPlaylist_bl = true;
			self.curId = id;
			self.playlist_ar = playlist;	
			self.countLoadedThumbs = 0;
			self.hideToolTipHandler();
			self.setupThumbnails();
			self.checkThumbsState();
			self.loadImages();
			
			if(self.position_str == "bottom"){
				FWDRVPTweenMax.to(self.thumbsHolder_do, .8, {y:parseInt((self.totalHeight - self.thumbH)/2), ease:Expo.easeInOut});
				FWDRVPTweenMax.to(self.nextButton_do, .8, {y:parseInt((self.stageHeight - self.nextButton_do.h)/2), ease:Expo.easeInOut});
				FWDRVPTweenMax.to(self.prevButton_do, .8, {y:parseInt((self.stageHeight - self.prevButton_do.h)/2), ease:Expo.easeInOut});
			}else{
				FWDRVPTweenMax.to(self.thumbsHolder_do, .8, {x:parseInt((self.totalWidth - self.thumbW)/2), ease:Expo.easeInOut});
				FWDRVPTweenMax.to(self.nextButton_do, .8, {x:parseInt((self.stageWidth - self.nextButton_do.w)/2), ease:Expo.easeInOut});
				FWDRVPTweenMax.to(self.prevButton_do, .8, {x:parseInt((self.stageWidth - self.prevButton_do.w)/2), ease:Expo.easeInOut});
			}
			self.resizeAndPosition();
		};
		
		this.setupThumbnails = function(){
			self.totalThumbs = self.playlist_ar.length;
			self.thumbs_ar = [];
			var thumb;
			for(var i=0; i<self.totalThumbs; i++){
				FWDRVPPlaylistThumb.setPrototype();
				thumb = new FWDRVPPlaylistThumb(
						self, 
						i, 
						data.playlistThumbnailsBackgroundPath_str,
						self.thumbW,
						self.thumbH);
				self.thumbs_ar[i] = thumb;
			
				thumb.addListener(FWDRVPPlaylistThumb.SHOW_TOOL_TIP, self.showToolTipHandler);
				thumb.addListener(FWDRVPPlaylistThumb.HIDE_TOOL_TIP, self.hideToolTipHandler);
				thumb.addListener(FWDRVPPlaylistThumb.MOUSE_UP, self.thumbMouseUpHandler);
				self.thumbsHolder_do.addChild(thumb);
			}
		};
		
		this.curThumbWithShowedTollTip = null;
		
		this.showToolTipHandler = function(e){
			if(!self.toolTip_do || !self.isShowed_bl) return;
			self.curThumbWithShowedTollTip = e.thumb;
			self.curThumbWithShowedTollTip.hasToolTipShowed_bl = true;
			
			if(window.addEventListener){
				window.addEventListener("mousemove", self.hideToolTipIfMouseIsNotHitting);
			}else if(document.attachEvent){
				document.detachEvent("onmousemove", self.hideToolTipIfMouseIsNotHitting);
				document.attachEvent("onmousemove", self.hideToolTipIfMouseIsNotHitting);
			}
			
			self.startToShowToolTip(e.thumb.id, e);
		};
		
		this.hideToolTipIfMouseIsNotHitting = function(e){
			if(!self.curThumbWithShowedTollTip) return;
			var wc = FWDRVPUtils.getViewportMouseCoordinates(e);	
			if(!FWDRVPUtils.hitTest(self.curThumbWithShowedTollTip.screen, wc.screenX, wc.screenY)){
				self.hideToolTipHandler();
			}
		};
		
		this.hideToolTipHandler = function(){
			if(!self.toolTip_do) return;
			var thumb;
			if(self.thumbs_ar){
				for(var i=0; i<self.totalThumbs; i++){
					thumb = self.thumbs_ar[i];
					if(thumb) thumb.hasToolTipShowed_bl = false;
				}
			}
			clearTimeout(self.showToolTipId_to);
			self.toolTip_do.hide();
			if(window.addEventListener){
				window.removeEventListener("mousemove", self.hideToolTipIfMouseIsNotHitting);
			}else if(document.attachEvent){
				document.detachEvent("onmousemove", self.hideToolTipIfMouseIsNotHitting);
			}
		};
		
		this.startToShowToolTip = function(id, e){
			clearTimeout(self.showToolTipId_to);
			if(!self.playlist_ar[id].title) return;		
			if(e) self.moveEvent = e;
			self.toolTip_do.setLabel(self.playlist_ar[id].title, id);
		
			
			self.showToolTipId_to = setTimeout(function(){
				self.showToolTip(self.thumbs_ar[id]);
			}, 152);
		};
		
		this.thumbMouseUpHandler = function(e){
			if(self.disableThumbs_bl) return;
			self.hideToolTipHandler();
			self.dispatchEvent(FWDRVPPlaylist.THUMB_MOUSE_UP, {id:e.id});
		};
			
		this.destroyPlaylist = function(){
			if(!self.thumbs_ar) return;
			var thumb;
			self.hasPlaylist_bl = false;
			self.image_img.onerror = null;
			self.image_img.onload = null;
			
			if(self.toolTip_do) self.toolTip_do.id = -1;
			
			if(self.position_str == "bottom"){
				FWDRVPTweenMax.killTweensOf(self.thumbsHolder_do);
				FWDRVPTweenMax.killTweensOf(self.nextButton_do);
				FWDRVPTweenMax.killTweensOf(self.prevButton_do);
				self.thumbsHolder_do.setY(self.totalHeight);
				self.nextButton_do.setY(self.totalHeight);
				self.prevButton_do.setY(self.totalHeight);
			}else{
				FWDRVPTweenMax.killTweensOf(self.thumbsHolder_do);
				FWDRVPTweenMax.killTweensOf(self.nextButton_do);
				FWDRVPTweenMax.killTweensOf(self.prevButton_do);
				self.thumbsHolder_do.setX(self.totalWidth);
				self.nextButton_do.setX(self.totalWidth);
				self.prevButton_do.setX(self.totalWidth);
			}
			
			clearTimeout(self.loadWithDelayId_to);
			for(var i=0; i<self.totalThumbs; i++){
				thumb = self.thumbs_ar[i];
				self.thumbsHolder_do.removeChild(thumb);
				thumb.destroy();
			}
			self.thumbs_ar = null;
		};
		
		//#############################################//
		/* load thumbnail images */
		//#############################################//
		this.loadImages = function(){
			if(!self.playlist_ar[self.countLoadedThumbs]) return;
			
			if(self.image_img){
				self.image_img.onload = null;
				self.image_img.onerror = null;
			}
			
			self.image_img = new Image();
			self.image_img.onerror = self.onImageLoadError;
			self.image_img.onload = self.onImageLoadComplete;
			
			self.image_img.src = self.playlist_ar[self.countLoadedThumbs].thumbSource;
		};
		
		this.onImageLoadError = function(e){};
		
		this.onImageLoadComplete = function(e){
			var thumb = self.thumbs_ar[self.countLoadedThumbs];
			thumb.setImage(self.image_img);
			self.countLoadedThumbs++;
			self.loadWithDelayId_to = setTimeout(self.loadImages, 40);	
		};
		
		//#####################################//
		/* enable disable thumbs based on id */
		//#####################################//
		this.checkThumbsState = function(){
			if(!self.thumbs_ar) return;
			var thumb;
			for(var i=0; i< self.totalThumbs; i++){
				thumb = self.thumbs_ar[i];
				if(i == self.curId){
					thumb.disable();
				}else{
					thumb.enable();
				}
			};
		};
		
		//################################//
		/* Setup tooltip */
		//################################//		
		this.setupToolTip = function(){
			FWDRVPPlaylistToolTip.setPrototype();
			self.toolTip_do = new FWDRVPPlaylistToolTip(data.playlistToolTipBackgroundPath_str, 
														data.playlistToolTipPointerPath_str, 
														self.toolTipsButtonFontColor_str,
														self.position_str,
														data.playlistToolTipMaxWidth);
			document.documentElement.appendChild(self.toolTip_do.screen);
		};
		
		this.showToolTip = function(thumb){
			
			var ws = FWDRVPUtils.getViewportSize();
			var wc = FWDRVPUtils.getViewportMouseCoordinates(self.moveEvent);
			
			var localX;
			var localY;
			var offsetX;
			
			if(self.position_str == "bottom"){
				if(thumb.screen.offsetWidth < 6){
					localX = parseInt(thumb.getGlobalX() * 100 + thumb.w/2 - self.toolTip_do.w/2);
					localY = parseInt(thumb.getGlobalY() * 100 - self.toolTip_do.h - 11);
				}else{
					localX = parseInt(thumb.getGlobalX() + thumb.w/2 - self.toolTip_do.w/2);
					localY = parseInt(thumb.getGlobalY() - self.toolTip_do.h - 11);
				}
				
				offseX = 0;
			
				if(localX < 0){
					offseX = localX;
					localX = 0;
				}else if(localX + self.toolTip_do.w > ws.w){
					offseX = (ws.w - (localX + self.toolTip_do.w)) * -1;
					localX = localX + (offseX * -1);
				}
			}else{
				localX = parseInt(thumb.getGlobalX() - self.toolTip_do.w - 11);
				localY = parseInt(thumb.getGlobalY() + thumb.h/2 - self.toolTip_do.h/2 );
				offseX = 0;
			}
			
			self.toolTip_do.positionPointer(offseX, false);
			
			
			self.toolTip_do.setX(localX);
			self.toolTip_do.setY(localY);
			self.toolTip_do.show();
		};
		
		//#######################################//
		/* position and resize thumbs */
		//#######################################//
		this.setDataForResize = function(){
			var dir;
			
			if(self.position_str == "bottom"){
			
				self.widthToResize = self.stageWidth - self.offsetToRemoveFromStage;
				
				self.howManyThumbsToDisplayH = Math.floor(self.widthToResize/self.thumbW);
				self.spacerH =  parseInt(self.widthToResize - (self.howManyThumbsToDisplayH * self.thumbW))/self.howManyThumbsToDisplayH;
				
				if(self.spacerH > 10)  self.howManyThumbsToDisplayH +=1;
				self.spacerH =  parseInt((self.widthToResize - (self.howManyThumbsToDisplayH * self.thumbW))/self.howManyThumbsToDisplayH);
				if(self.spacerH < 10)  self.howManyThumbsToDisplayH -=1;
				self.spacerH =  parseInt((self.widthToResize - (self.howManyThumbsToDisplayH * self.thumbW))/self.howManyThumbsToDisplayH);
			
				if(self.howManyThumbsToDisplayH < 1) self.howManyThumbsToDisplayH = 1;
				
				if(self.howManyThumbsToDisplayH > self.totalThumbs) self.spacerH = 13;
			
				if(self.howManyThumbsToDisplayH >= self.totalThumbs){
					self.totalWidth = Math.floor((self.totalThumbs * (self.thumbW + self.spacerH))) - self.spacerH;
					self.allowToSwipe_bl = false;
				}else{
					self.totalWidth = Math.floor((self.howManyThumbsToDisplayH * (self.thumbW + self.spacerH))) - self.spacerH;
					self.allowToSwipe_bl = true;
				}
			
				if(self.howManyThumbsToDisplayH > self.totalThumbs){
					self.leftId = 0;
				}else if(self.leftId + self.howManyThumbsToDisplayH >= self.totalThumbs - 1){
					self.leftId = self.totalThumbs - self.howManyThumbsToDisplayH;
				}
				
				dir = Math.floor((self.curId - self.leftId) / self.howManyThumbsToDisplayH);
			
				self.thumbsHolder_do.setX(Math.round((self.stageWidth - self.totalWidth)/2));
				self.thumbsHolder_do.setWidth(self.totalWidth);
				self.thumbsHolder_do.setHeight(self.thumbH);
				
				self.gotoNextSet(dir);
			}else{
				self.heightToResize = self.stageHeight - self.offsetToRemoveFromStage;
				
				self.howManyThumbsToDisplayV = Math.floor(self.heightToResize/self.thumbH);
				self.spacerV =  parseInt(self.widthToResize - (self.howManyThumbsToDisplayV * self.thumbH))/self.howManyThumbsToDisplayV;
				
				if(self.spacerV > 10)  self.howManyThumbsToDisplayV +=1;
				self.spacerV =  parseInt((self.heightToResize - (self.howManyThumbsToDisplayV * self.thumbH))/self.howManyThumbsToDisplayV);
				if(self.spacerV < 10)  self.howManyThumbsToDisplayV -=1;
				self.spacerV = parseInt((self.heightToResize - (self.howManyThumbsToDisplayV * self.thumbH))/self.howManyThumbsToDisplayV);
				
				if(self.howManyThumbsToDisplayV < 1) self.howManyThumbsToDisplayV = 1;
				
				if(self.howManyThumbsToDisplayV > self.totalThumbs) self.spacerV = 13;
				
				
				if(self.howManyThumbsToDisplayV >= self.totalThumbs){
					self.totalHeight = Math.floor((self.totalThumbs * (self.thumbH + self.spacerV))) - self.spacerV;
					self.allowToSwipe_bl = false;
				}else{
					self.totalHeight = Math.floor((self.howManyThumbsToDisplayV * (self.thumbH + self.spacerV))) - self.spacerV;
					self.allowToSwipe_bl = true;
				}
				
				if(self.howManyThumbsToDisplayV > self.totalThumbs){
					self.leftId = 0;
				}else if(self.leftId + self.howManyThumbsToDisplayV >= self.totalThumbs - 1){
					self.leftId = self.totalThumbs - self.howManyThumbsToDisplayV;
				}
				
				dir = Math.floor((self.curId - self.leftId) / self.howManyThumbsToDisplayV);
				
				self.thumbsHolder_do.setY(Math.round((self.stageHeight - self.totalHeight)/2));
				self.thumbsHolder_do.setHeight(self.totalHeight);
				self.thumbsHolder_do.setWidth(self.thumbW);
				
				self.gotoNextSet(dir);
			}
		};
		
		this.positionThumbs = function(animate, direction){
			if(!self.thumbs_ar) return;
			var thumb;
			var curX;
			var curY;
			var dl = 0;
		
			if(self.position_str == "bottom"){
				for(var i=0; i<self.totalThumbs; i++){
					if(!animate){
						thumb = self.thumbs_ar[i];
						curX = (i - self.leftId) * (self.thumbW + self.spacerH);
						FWDRVPTweenMax.killTweensOf(thumb);
						
						if(i - self.leftId < 0){
							curX -= parseInt(self.offsetToRemoveFromStage/3 +19); 
						}else if(i - self.leftId > self.howManyThumbsToDisplayH - 1){
							curX += parseInt(self.offsetToRemoveFromStage/3 +19); 
						}
						
						FWDRVPTweenMax.killTweensOf(thumb);
						thumb.setX(curX);
					}
				}
				
				if(animate && direction == "right"){
					for(var i=0; i<self.totalThumbs; i++){
						thumb = self.thumbs_ar[i];
						FWDRVPTweenMax.killTweensOf(thumb);
						curX = (i - self.leftId) * (self.thumbW + self.spacerH);
						
						if(i - self.leftId < 0){
							curX -= parseInt(self.offsetToRemoveFromStage/3 +19); 
						}else if(i - self.leftId > self.howManyThumbsToDisplayH - 1){
							curX += parseInt(self.offsetToRemoveFromStage/3 +19); 
						}
						
						if(i - self.leftId < 0){
							FWDRVPTweenMax.to(thumb, .8, {x:curX, ease:Expo.easeInOut});
						}else{
							FWDRVPTweenMax.to(thumb, .8, {x:curX, delay:dl, ease:Expo.easeInOut});
							dl += 0.02;
						}
					}
				}else if(animate && direction == "left"){
					for(var i=self.totalThumbs-1; i>=self.leftId; i--){
						thumb = self.thumbs_ar[i];
						FWDRVPTweenMax.killTweensOf(thumb);
						curX = (i - self.leftId) * (self.thumbW + self.spacerH);
						if(i - self.leftId < 0){
							curX -= parseInt(self.offsetToRemoveFromStage/3 +19); 
						}else if(i - self.leftId > self.howManyThumbsToDisplayH - 1){
							curX += parseInt(self.offsetToRemoveFromStage/3 +19); 
						}
						if(i - self.leftId > self.howManyThumbsToDisplayH - 1){
							FWDRVPTweenMax.to(thumb, .8, {x:curX, ease:Expo.easeInOut});
						}else{
							FWDRVPTweenMax.to(thumb, .8, {x:curX, delay:dl, ease:Expo.easeInOut});
							dl += 0.02;
						}
					}
				}
			}else{
				for(var i=0; i<self.totalThumbs; i++){
					if(!animate){
						thumb = self.thumbs_ar[i];
						curY = (i - self.leftId) * (self.thumbH + self.spacerV);
						FWDRVPTweenMax.killTweensOf(thumb);
						
						if(i - self.leftId < 0){
							curY -= parseInt(self.offsetToRemoveFromStage/3 +19); 
						}else if(i - self.leftId > self.howManyThumbsToDisplayV - 1){
							curY += parseInt(self.offsetToRemoveFromStage/3 +19); 
						}
						
						FWDRVPTweenMax.killTweensOf(thumb);
						thumb.setY(curY);
					}
				}
				
				if(animate && direction == "right"){
					for(var i=0; i<self.totalThumbs; i++){
						thumb = self.thumbs_ar[i];
						FWDRVPTweenMax.killTweensOf(thumb);
						curY = (i - self.leftId) * (self.thumbH + self.spacerV);
						
						if(i - self.leftId < 0){
							curY -= parseInt(self.offsetToRemoveFromStage/3 +19); 
						}else if(i - self.leftId > self.howManyThumbsToDisplayV - 1){
							curY += parseInt(self.offsetToRemoveFromStage/3 +19); 
						}
						
						if(i - self.leftId < 0){
							FWDRVPTweenMax.to(thumb, .8, {y:curY, ease:Expo.easeInOut});
						}else{
							FWDRVPTweenMax.to(thumb, .8, {y:curY, delay:dl, ease:Expo.easeInOut});
							dl += 0.02;
						}
					}
				}else if(animate && direction == "left"){
					for(var i=self.totalThumbs-1; i>=self.leftId; i--){
						thumb = self.thumbs_ar[i];
						curY = (i - self.leftId) * (self.thumbH + self.spacerV);
						FWDRVPTweenMax.killTweensOf(thumb);
						
						if(i - self.leftId < 0){
							curY -= parseInt(self.offsetToRemoveFromStage/3 +19); 
						}else if(i - self.leftId > self.howManyThumbsToDisplayV - 1){
							curY += parseInt(self.offsetToRemoveFromStage/3 +19); 
						}
						
						if(i - self.leftId > self.howManyThumbsToDisplayV - 1){
							FWDRVPTweenMax.to(thumb, .8, {y:curY, ease:Expo.easeInOut});
						}else{
							FWDRVPTweenMax.to(thumb, .8, {y:curY, delay:dl, ease:Expo.easeInOut});
							dl += 0.02;
						}
					}
				}
			}
		};
		
		//################################//
		/* Thumbnails navigations */
		//################################//
		this.gotoNextSet = function(dir){
			if(self.position_str == "bottom"){
				if(dir > 0){	
					self.leftId += self.howManyThumbsToDisplayH  *  dir;
					if(self.leftId > self.totalThumbs -1 -  self.howManyThumbsToDisplayH){
						self.leftId = self.totalThumbs - self.howManyThumbsToDisplayH;
					}else if(self.leftId <= 0){
						self.leftId = 0;
					}
					self.positionThumbs(true, "right");
				}else if(dir < 0){
					self.leftId -= self.howManyThumbsToDisplayH  * - dir;
					
					if(self.leftId <= 0){
						self.leftId = 0;
					}
					self.positionThumbs(true, "left");
				}
			}else{
				if(dir > 0){	
					self.leftId += self.howManyThumbsToDisplayV  *  dir;
					if(self.leftId > self.totalThumbs -1 -  self.howManyThumbsToDisplayV){
						self.leftId = self.totalThumbs - self.howManyThumbsToDisplayV;
					}else if(self.leftId <= 0){
						self.leftId = 0;
					}
					self.positionThumbs(true, "right");
				}else if(dir < 0){
					self.leftId -= self.howManyThumbsToDisplayV  * - dir;
					if(self.leftId <= 0){
						self.leftId = 0;
					}
					self.positionThumbs(true, "left");
				}
			}
			self.enableDisableNextAndPrevButtons();
		};
		
		//################################//
		/* Setup next and prev buttons */
		//################################//
		this.setupNextAndPrevButtons = function(){
			FWDRVPSimpleButton.setPrototype();
			self.nextButton_do = new FWDRVPSimpleButton(data.nextThumbsSetN_img, data.nextThumbsSetSPath_str, undefined, true);
			self.nextButton_do.addListener(FWDRVPSimpleButton.MOUSE_UP, self.nextButtonOnMouseUpHandler);
			self.mainHolder_do.addChild(self.nextButton_do); 
			
			FWDRVPSimpleButton.setPrototype();
			self.prevButton_do = new FWDRVPSimpleButton(data.prevThumbsSetN_img, data.prevThumbsSetSPath_str, undefined, true);
			self.prevButton_do.addListener(FWDRVPSimpleButton.MOUSE_UP, self.prevButtonOnMouseUpHandler);
			self.mainHolder_do.addChild(self.prevButton_do); 
		};
		
		this.nextButtonOnMouseUpHandler = function(){
			self.gotoNextSet(1);
			clearTimeout(self.thumbnailsAnimDoneId_to);
			self.showToolTipOnAnimComplete();
		};
		
		this.prevButtonOnMouseUpHandler = function(){
			self.gotoNextSet(-1);
			clearTimeout(self.thumbnailsAnimDoneId_to);
			self.showToolTipOnAnimComplete();
		};
	
		this.positionNextAndPrevButtons = function(){
			if(self.position_str == "bottom"){
				if(self.howManyThumbsToDisplayH < self.totalThumbs){
					var leftWidth = (self.stageWidth - self.totalWidth)/2;
					self.nextButton_do.setX(parseInt(self.stageWidth - self.nextButton_do.w -(leftWidth - self.nextButton_do.w)/2));
					self.prevButton_do.setX(parseInt(leftWidth - self.prevButton_do.w)/2);
				}else{
					self.nextButton_do.setX(self.stageWidth - self.nextButton_do.w - self.nextAndPrevSetButtonsMargins);
					self.prevButton_do.setX(self.nextAndPrevSetButtonsMargins);
				}
			}else if(self.position_str == "right"){
				if(self.howManyThumbsToDisplayV < self.totalThumbs){
					var leftHeight = (self.stageHeight - self.totalHeight)/2;
					self.nextButton_do.setY(parseInt(self.stageHeight - self.nextButton_do.h -(leftHeight - self.nextButton_do.h)/2) - 1);
					self.prevButton_do.setY(parseInt(leftHeight - self.prevButton_do.h)/2 + 1);
				}else{
					self.nextButton_do.setY(self.stageHeight - self.nextButton_do.w - self.nextAndPrevSetButtonsMargins);
					self.prevButton_do.setY(self.nextAndPrevSetButtonsMargins);
				}
				
			}
		};
		
		this.enableDisableNextAndPrevButtons = function(){		
			if(self.curId == 0){
				self.disablePrevButton();
				self.enableNextButton();
			}else if(self.curId == self.totalThumbs - 1){
				self.disableNextButton();
				self.enablePrevButton();
			}else{
				self.enablePrevButton();
				self.enableNextButton();
			}
			
			if(self.position_str == "bottom"){
				if(self.howManyThumbsToDisplayH >= self.totalThumbs){
					self.disableNextButton();
					self.disablePrevButton();
				}else if(self.leftId >= self.totalThumbs -  self.howManyThumbsToDisplayH){
					self.disableNextButton();
					self.enablePrevButton();
				}else if(self.leftId <=0){
					self.enableNextButton();
					self.disablePrevButton();
				}else{
					self.enableNextButton();
					self.enablePrevButton();
				}
			}else{
				if(self.howManyThumbsToDisplayV >= self.totalThumbs){
					self.disableNextButton();
					self.disablePrevButton();
				}else if(self.leftId >= self.totalThumbs -  self.howManyThumbsToDisplayV){
					self.disableNextButton();
					self.enablePrevButton();
				}else if(self.leftId <=0){
					self.enableNextButton();
					self.disablePrevButton();
				}else{
					self.enableNextButton();
					self.enablePrevButton();
				}
			}
		};
		
		this.disablePrevButton = function(){
			self.prevButton_do.disable();
		};
		
		this.enablePrevButton = function(){
			self.prevButton_do.enable();
		};
		
		this.disableNextButton = function(){
			 self.nextButton_do.disable();
		};
		
		this.enableNextButton = function(){
			self.nextButton_do.enable();
		};
		
		//###############################//
		/* setup disable */
		//##############################//
		this.setupDisable = function(){
			self.disable_do = new FWDRVPDisplayObject("div");
			if(FWDRVPUtils.isIE){
				self.disable_do.setBkColor("#FFFFFF");
				self.disable_do.setAlpha(0.001);
			}
			self.addChild(self.disable_do);
		};
		
		this.showDisable = function(){
			if(self.disable_do.w == self.stageWidth) return;
			self.disable_do.setWidth(self.stageWidth);
			self.disable_do.setHeight(self.stageHeight);
		};
		
		this.hideDisable = function(){
			if(self.disable_do.w == 0) return;
			self.disable_do.setWidth(0);
			self.disable_do.setHeight(0);
		};
		
		//##########################################//
		/* setup mobile scrollbar */
		//##########################################//
		this.setupMobileMove = function(){	
			if(self.hasPointerEvent_bl){
				self.screen.addEventListener("MSPointerDown", self.mobileDownHandler);
			}else{
				self.screen.addEventListener("touchstart", self.mobileDownHandler);
			}
		};
		
		this.mobileDownHandler = function(e){
			if(!self.allowToSwipe_bl || !self.hasPlaylist_bl) return;
			if (e.touches) if(e.touches.length != 1) return;
			var viewportMouseCoordinates = FWDRVPUtils.getViewportMouseCoordinates(e);	
			self.mouseX = viewportMouseCoordinates.screenX;;
			self.mouseY = viewportMouseCoordinates.screenY;
			if(self.hasPointerEvent_bl){
				window.addEventListener("MSPointerUp", self.mobileUpHandler);
				window.addEventListener("MSPointerMove", self.mobileMoveHandler);
			}else{
				window.addEventListener("touchend", self.mobileUpHandler);
				window.addEventListener("touchmove", self.mobileMoveHandler);
			}
		};
		
		this.mobileMoveHandler = function(e){
			if(e.preventDefault) e.preventDefault();
			if (e.touches) if(e.touches.length != 1) return;
			self.showDisable();
			var viewportMouseCoordinates = FWDRVPUtils.getViewportMouseCoordinates(e);
			if(self.position_str == "bottom"){
				self.dif = self.mouseX - viewportMouseCoordinates.screenX;
			}else{
				self.dif = self.mouseY - viewportMouseCoordinates.screenY;
			}
			self.mouseX = viewportMouseCoordinates.screenX;
			self.mouseY = viewportMouseCoordinates.screenY;
		};
		
		this.mobileUpHandler = function(e){
			self.hideDisable();
			if(self.dif > 3){
				self.gotoNextSet(1);
			}else if(self.dif < -3){
				self.gotoNextSet(-1);
			}
			self.dif = 0;
			
			if(self.hasPointerEvent_bl){
				window.removeEventListener("MSPointerUp", self.mobileUpHandler, false);
				window.removeEventListener("MSPointerMove", self.mobileMoveHandler);
			}else{
				window.removeEventListener("touchend", self.mobileUpHandler);
				window.removeEventListener("touchmove", self.mobileMoveHandler);
			}
		};
		
		//###########################################//
		/* Add mousewheel support */
		this.addMouseWheelSupport = function(){
			if(self.screen.addEventListener){
				self.screen.addEventListener('DOMMouseScroll', self.mouseWheelHandler);
				self.screen.addEventListener ("mousewheel", self.mouseWheelHandler);
			}else if(self.screen.attachEvent){
				self.screen.attachEvent('onmousewheel', self.mouseWheelHandler);
			}
		};
		
		this.mouseMoveHandler = function(e){
			var wp = FWDRVPUtils.getViewportMouseCoordinates(e);	
			self.mouseX = wp.screenX;
			self.mouseY = wp.screenY;
		};
		
		self.mouseWheelHandler = function(e){
			if(e.preventDefault) e.preventDefault();
			if(self.disableMouseWheel_bl) return false;
			var thumb;
			
			var dir = e.detail || e.wheelDelta;	
			if(e.wheelDelta) dir *= -1;
			if(FWDRVPUtils.isOpera) dir *= -1;
			
			if(dir > 0){
				if(self.position_str == "bottom"){
					if(self.leftId >= self.totalThumbs -1 -  self.howManyThumbsToDisplayH) return;
				}else{
					if(self.leftId >= self.totalThumbs -1 -  self.howManyThumbsToDisplayV) return;
				}
				
				self.gotoNextSet(1);
			}else if(dir < 0){
				if(self.leftId <= 0) return;
				self.gotoNextSet(-1);
			}
			
			
			self.showToolTipOnAnimComplete();
		
			if(e.preventDefault){
				e.preventDefault();
			}else{
				return false;
			}
		};
		
		this.showToolTipOnAnimComplete = function(){
			if(self.isMobile_bl) return;
			var dealy = 0;
			if(self.position_str == "bottom"){
				delay = 900 + 20 * self.howManyThumbsToDisplayH;
			}else{
				delay = 900 + 20 * self.howManyThumbsToDisplayH;
			}
			clearTimeout(self.showToolTipId_to);
			self.disableMouseWheel_bl = true;
			clearTimeout(self.disableMouseWheelId_to);
			self.hideToolTipHandler();
			self.disableMouseWheelId_to = setTimeout(function(){
				self.disableMouseWheel_bl = false;
				for(var i=0; i<self.totalThumbs; i++){
					
					thumb = self.thumbs_ar[i];
					if(FWDRVPUtils.hitTest(thumb.screen, self.mouseX, self.mouseY)){
					
						self.startToShowToolTip(thumb.id);
						break;
					}
				}
			}, delay);
		};
	
		
		//################################//
		/* show / hide */
		//################################//
		this.hideAndShow = function(animate){
			if(self.position_str == "bottom"){
				self.mainHolder_do.setY(self.totalHeight);
				FWDRVPTweenMax.to(self.mainHolder_do, .8, {y:0, ease:Expo.easeInOut});
			}else{
				self.mainHolder_do.setX(self.totalWidth);
				FWDRVPTweenMax.to(self.mainHolder_do, .8, {x:0, ease:Expo.easeInOut});
			}
		};
		
		this.hide = function(animate){
			self.isShowed_bl = false;
			if(animate){
				if(self.position_str == "bottom"){
					FWDRVPTweenMax.to(self.mainHolder_do, .8, {y:self.stageHeight, ease:Expo.easeInOut});
				}else{
					FWDRVPTweenMax.to(self.mainHolder_do, .8, {x:self.stageWidth, ease:Expo.easeInOut});
				}
			}else{
				FWDRVPTweenMax.killTweensOf(self.mainHolder_do);
				if(self.position_str == "bottom"){
					self.mainHolder_do.setY(self.stageHeight);
				}else{
					self.mainHolder_do.setX(self.stageWidth);
				}
			}
		};
		
		this.show = function(animate){
			self.isShowed_bl = true;
			if(animate){
				if(self.position_str == "bottom"){
					FWDRVPTweenMax.to(self.mainHolder_do, .8, {y:0, ease:Expo.easeInOut});
				}else{
					FWDRVPTweenMax.to(self.mainHolder_do, .8, {x:0, ease:Expo.easeInOut});
				}
			}else{
				FWDRVPTweenMax.killTweensOf(self.mainHolder_do);
				if(self.position_str == "bottom"){
					self.mainHolder_do.setY(0);
				}else{
					self.mainHolder_do.setX(0);
				}
				clearTimeout(self.disableThumbsId_to);
				self.disableThumbsId_to =  setTimeout(function(){self.disableThumbs_bl = false;}, 200);
				self.disableThumbs_bl = true;
			}
		};
	
		this.init();
	};
	
	/* set prototype */
    FWDRVPPlaylist.setPrototype = function(){
    	FWDRVPPlaylist.prototype = new FWDRVPDisplayObject("div", "absolute", "visible");
    };
    
    FWDRVPPlaylist.THUMB_MOUSE_UP = "thumbMouseOut";
    
    FWDRVPPlaylist.prototype = null;
	window.FWDRVPPlaylist = FWDRVPPlaylist;
}(window));