/* FWDRVPPlaylistThumb */
(function (window){
	var FWDRVPPlaylistThumb = function(
			parent,
			pId, 
			backgroundImagePath,
			thumbWidth,
			thumbHeight
		){
		
		var self = this;
		var prototype = FWDRVPPlaylistThumb.prototype;
	
		this.imageHolder_do = null;
		this.normalImage_do = null;
		this.is8Over_do = null;
			
		this.backgroundImagePath_str = backgroundImagePath;
	
		this.id = pId;
		this.imageOriginalW;
		this.imageOriginalH;
		this.finalX;
		this.finalY;
		this.finalW = thumbWidth;
		this.finalH = thumbHeight;
		this.imageFinalX;
		this.imageFinalY;
		this.imageFinalW;
		this.imageFinalH;
		this.mouseX;
		this.mouseY;
		
		this.showId_to;
		this.disableForAWhileId_to;
	
		this.hasImage_bl = false;
		this.isSelected_bl = false;
		this.isDisabled_bl = false;
		this.disableForAWhile_bl = false;
		this.hasToolTipShowed_bl = false;
		this.hasCanvas_bl = FWDRVPlayer.hasCanvas;
		this.isMobile_bl = FWDRVPUtils.isMobile;
		this.hasPointerEvent_bl = FWDRVPUtils.hasPointerEvent;
		this.hasDispatchedOverEvent_bl = false;

		this.init = function(){
			self.getStyle().background = "url('" + self.backgroundImagePath_str + "')";
			self.setupMainContainers();
			
			if(FWDRVPUtils.isIEAndLessThen9){
				self.is8Over_do = new FWDRVPDisplayObject("div");
				self.is8Over_do.setBkColor("#000000");
				self.is8Over_do.setAlpha(0);
				self.is8Over_do.setWidth(self.finalW);
				self.is8Over_do.setHeight(self.finalH);
				self.addChild(self.is8Over_do);
			}
			
			self.setWidth(self.finalW);
			self.setHeight(self.finalH);
			self.setButtonMode(true);
			
			if(self.isMobile_bl){
				if(self.hasPointerEvent_bl){
					self.screen.addEventListener("MSPointerUp", self.onMouseUp);
				}else{
					self.screen.addEventListener("click", self.onMouseUp);
				}
			}else if(self.screen.addEventListener){	
				self.screen.addEventListener("mouseout", self.thumbMouseOut);
				self.screen.addEventListener("mousemove", self.thumbMouseMove);
				self.screen.addEventListener("click", self.onMouseUp);
			}else if(self.screen.attachEvent){
				//self.screen.attachEvent("onmouseout", self.thumbMouseOut);
				self.screen.attachEvent("onmousemove", self.thumbMouseMove);
				self.screen.attachEvent("onclick", self.onMouseUp);
			}
		};
		
		//#################################//
		/* set image */
		//#################################//
		this.setupMainContainers = function(){
			self.imageHolder_do = new FWDRVPDisplayObject("div");
			self.addChild(self.imageHolder_do);
		};
	
		//#################################//
		/* set image */
		//#################################//
		this.setImage = function(image){
			
			self.normalImage_do = new FWDRVPDisplayObject("img");
			self.normalImage_do.setScreen(image);
			
			self.imageOriginalW = self.normalImage_do.w;
			self.imageOriginalH = self.normalImage_do.h;
		
			self.resizeImage();
			
			self.imageHolder_do.setX(parseInt(self.finalW/2));
			self.imageHolder_do.setY(parseInt(self.finalH/2));
			self.imageHolder_do.setWidth(0);
			self.imageHolder_do.setHeight(0);
			
			self.normalImage_do.setX(- parseInt(self.normalImage_do.w/2));
			self.normalImage_do.setY(- parseInt(self.normalImage_do.h/2));
			
			
			FWDRVPTweenMax.to(self.imageHolder_do, .8, {
				x:0, 
				y:0,
				w:self.finalW,
				h:self.finalH, 
				ease:Expo.easeInOut});
			self.normalImage_do.setAlpha(0);
			
			if(self.isMobile_bl){
				var curAlpha;
				if(self.id == parent.curId){
					curAlpha = .3;
				}else{
					curAlpha = 1;
				}
			
				FWDRVPTweenMax.to(self.normalImage_do, .8, {
					alpha:curAlpha,
					x:self.imageFinalX, 
					y:self.imageFinalY, 
					ease:Expo.easeInOut});
				
			}else{
				
				FWDRVPTweenMax.to(self.normalImage_do, .8, {
					alpha:1,
					x:self.imageFinalX, 
					y:self.imageFinalY, 
					ease:Expo.easeInOut});
			}
		  
			self.imageHolder_do.addChild(self.normalImage_do);
			this.hasImage_bl = true;
		};
		
		self.thumbMouseMove = function(e){
			if(FWDRVPTweenMax.isTweening(self) || self.hasToolTipShowed_bl || self.disableForAWhile_bl) return;
			var wc = FWDRVPUtils.getViewportMouseCoordinates(e);	
			
			clearTimeout(self.showId_to);
			self.showId_to = setTimeout(function(){
				self.dispatchEvent(FWDRVPPlaylistThumb.SHOW_TOOL_TIP, {thumb:self, e:e});
			}, 50);
		};
		
		self.onMouseUp = function(e){
			if(self.isDisabled_bl || e.button == 2) return;
			if(e.preventDefault) e.preventDefault();
			self.dispatchEvent(FWDRVPPlaylistThumb.MOUSE_UP, {id:self.id});
		};
	
		//#################################//
		/* resize thumbnail*/
		//#################################//
		this.resizeAndPosition = function(animate, dl){
			
			FWDRVPTweenMax.killTweensOf(self);
			FWDRVPTweenMax.killTweensOf(self.imageHolder_do);
			
			if(animate){
				FWDRVPTweenMax.to(self, .8, {
					x:self.finalX, 
					y:self.finalY,
					delay:dl,
					ease:Expo.easeInOut});
			}else{
				self.setX(self.finalX);
				self.setY(self.finalY);
			}
			
			
			self.imageHolder_do.setX(0);
			self.imageHolder_do.setY(0);
			self.imageHolder_do.setWidth(self.finalW);
			self.imageHolder_do.setHeight(self.finalH);
			
			self.resizeImage();
		};
	
		//#################################//
		/* resize image*/
		//#################################//
		this.resizeImage = function(animate){
			
			if(!self.normalImage_do) return;
			FWDRVPTweenMax.killTweensOf(self.normalImage_do);
			var scX = self.finalW/self.imageOriginalW;
			var scY = self.finalH/self.imageOriginalH;
			var ttsc;
			
			if(scX <= scY){
				ttsc = scX;
			}else{
				ttsc = scY;
			}
			
			self.imageFinalW = Math.ceil(ttsc * self.imageOriginalW);
			self.imageFinalH = Math.ceil(ttsc * self.imageOriginalH);
			self.imageFinalX = Math.round((self.finalW - self.imageFinalW)/2);
			self.imageFinalY = Math.round((self.finalH - self.imageFinalH)/2);
		
			self.normalImage_do.setX(self.imageFinalX);
			self.normalImage_do.setY(self.imageFinalY);
			self.normalImage_do.setWidth(self.imageFinalW);
			self.normalImage_do.setHeight(self.imageFinalH);
		};
		
		//###############################//
		/* enable / disable */
		//##############################//
		this.enable = function(){
			if(!self.isDisabled_bl) return;
			self.isDisabled_bl = false;
			self.setButtonMode(true);
			if(FWDRVPUtils.isIEAndLessThen9){
				self.is8Over_do.setAlpha(0);
			}else{
				if(self.isMobile_bl){
					if(self.normalImage_do) self.normalImage_do.setAlpha(1);
				}else{
					FWDRVPTweenMax.to(self.imageHolder_do, .6, {alpha:1});
				}
			}
		};
		
		this.disable = function(){
			if(self.isDisabled_bl) return;
			self.disableForAWhile_bl = true;
			clearTimeout(self.disableForAWhileId_to);
			self.disableForAWhileId_to = setTimeout(function(){
				self.disableForAWhile_bl = false;
			}, 200);
			self.isDisabled_bl = true;
			self.setButtonMode(false);
			if(FWDRVPUtils.isIEAndLessThen9){
				self.is8Over_do.setAlpha(.8);
			}else{
				if(self.isMobile_bl){
					if(self.normalImage_do) self.normalImage_do.setAlpha(.3);
				}else{
					FWDRVPTweenMax.to(self.imageHolder_do, .6, {alpha:.3});
				}
			}
		};
		
		//################################//
		/* Destroy */
		//################################//
		this.destroy = function(){
			FWDRVPTweenMax.killTweensOf(self);
			if(self.normalImage_do){
				FWDRVPTweenMax.killTweensOf(self.normalImage_do);
				self.normalImage_do.destroy();
			}
			
			FWDRVPTweenMax.killTweensOf(self.imageHolder_do);
			self.imageHolder_do.destroy();
			
			self.backgroundImagePath_str = backgroundImagePath;
			self.imageHolder_do = null;
			self.normalImage_do = null;
		};
	
		this.init();
	};
	
	/* set prototype */
	FWDRVPPlaylistThumb.setPrototype = function(){
		FWDRVPPlaylistThumb.prototype = new FWDRVPDisplayObject("div");
	};
	
	FWDRVPPlaylistThumb.SHOW_TOOL_TIP = "showToolTip";
	FWDRVPPlaylistThumb.HIDE_TOOL_TIP = "hideToolTip";
	FWDRVPPlaylistThumb.MOUSE_UP = "onMouseUp";
	
	FWDRVPPlaylistThumb.prototype = null;
	window.FWDRVPPlaylistThumb = FWDRVPPlaylistThumb;
}(window));